<?php

    ini_set('memory_limit', '1024M');
    set_time_limit(0);
    ini_set('max_execution_time', 7200);
    ini_set('display_errors', 1);
    ini_set("log_errors", 1);
    ini_set("error_log", "mls_import.txt");

    error_reporting(E_ALL);
    date_default_timezone_set('America/Toronto');
    echo "<pre>";

    $mtime   = microtime();
    $mtime   = explode(" ", $mtime);
    $mtime   = $mtime[1] + $mtime[0];
    $t_start = $mtime;
        
        
    function getbridgedata($curr_url= ''){
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $curr_url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 300,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_POSTFIELDS => "",
            CURLOPT_HTTPHEADER => array(
                "Content-Type: application/x-www-form-urlencoded",
                "Postman-Token: 2c89f0ab-d710-4932-b69a-7cc881bb7d30",
                "cache-control: no-cache"
            ),
        ));
        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        if ($err) {
            $return['status'] = false ;
        } else {
            $return['status'] = true ;
        }
        $json_data = json_decode($response, true);
        $return['json_data'] = $json_data;
        return $return ;
    }
    
    require_once("config/db_config.php");
    require_once("config/properties_config.php");
    require_once("config/mls_config.php");
    require_once('library/vendor/MysqliDb.php');
    require_once("library/phrets.php");
    
    $dbcron = new MysqliDb($servername, $db_username, $db_password, $dbname);
    $dbproperty =new MysqliDb($servername, $db_username, $db_password, $dbname);
    
    $com_map = array(
        'ListingKeyNumeric'=>'ListingKeyNumeric',
        'Heating'=>'Heating',
        'ListingId'=>'ListingId',
        'RoomsTotal'=>'RoomsTotal',
        'Furnished'=>'Furnished',
        'Longitude'=>'Longitude',
        'Zoning'=>'Zoning',
        'Latitude'=>'Latitude',
        'ListPrice'=>'ListPrice',
        'Stories'=>'Stories',
        'Sewer'=>'Sewer',
        'GarageSpaces'=>'GarageSpaces',
        'Ml_num'=>'ListingId',
        'OrigListingID'=>'ListingId',
        'BedsTotal'=>'BedroomsTotal',
        'Br_plus'=>'ITSO_BedsAboveGrade',
        'BathsFull'=>'BathroomsFull',
        'Apt_num'=>'UnitNumber',
        'postalcode'=>'PostalCode',
        'age'=>'YearBuilt',
        'Yr'=>'YearBuilt',
        //'Dom'=>'ListingId',
        'Timestamp_sql'=>'BridgeModificationTimestamp',
        'Area'=>'MLSAreaMajor',
        'Community'=>'MLSAreaMajor',
        //'Municipality_code'=>'ListingId',
        'A_c'=>'Cooling',
        'Ad_text'=>'PublicRemarks',
        'Addr'=>'UnparsedAddress',
        'County'=>'CountyOrParish',
        'Gar_type'=>'ParkingFeatures',
        'Heat_inc'=>'HeatingYN',
        'OriginalListDate'=>'ListingContractDate',
        'Orig_dol'=>'ITSO_CurrentPrice',
        'Parcel_id'=>'ParcelNumber',
        'Park_fac'=>'ITSO_DrivewayParking',
        'StructureSqFt'=>'ITSO_LivingAreaSrchSqFt',
        'St'=>'StreetName',
        //'St_dir'=>'ListingId',
        'St_num'=>'StreetNumber',
        'St_sfx'=>'StreetSuffix',
        'ListingStatus'=>'MlsStatus',
        'Style'=>'ArchitecturalStyle',
        'Type_own_srch'=>'PropertySubType',
        'Subclass'=>'PropertySubType',
        'cityname'=>'City',
        'Pix_updt'=>'PhotosChangeTimestamp',
        //'Xd'=>'ListingId',
        'PropertyID'=>'ListingId',
        'ListPrice'=>'ListPrice',
        'BathsHalf'=>'BathroomsHalf',
        'LivingSqFt'=>'BuildingAreaTotal',
        'ListDate'=>'ListingContractDate',
        'Laundry'=>'LaundryFeatures',
        'Park_desig'=>'ParkingFeatures',
        //'Park_desig'=>'ParkingFeatures',
        'Pool'=>'PoolFeatures',
        'Fpl_num'=>'FireplacesTotal',//'FireplaceFeatures',
        'Pets'=>'PetsAllowed',
        'Park_spcs'=>'ParkingTotal',
        'Bsmt1_out'=>'Basement',
        'Rltr'=>'ListOfficeName',
        'StructureSqFt'=>'BuildingAreaTotal',
        'Constr1_out'=>'ConstructionMaterials',
        'Acres'=>'ITSO_AcresRange'
        
    );
    
    $timestamp_field = 'Timestamp_sql'; 
    $file_name       = "mls_import2.php";
    $curr_resource   = "Property";
    $mls_key_field   = "ListingId";
    $curr_mls_id     = 2;
    $curr_date          = date('Y-m-d H:i:s');
    $cron_tablename     = 'properties_cron_log';
    $tmp_tablename      = 'property_queue';
    
    $all_classes = array(
        'RESI'=>array('ClassName'=>'Residential','TableName'=>'rets_property_data_reso')
        );
    
    foreach($all_classes as $classkey=> $classdata ) {
        $className = $classdata['ClassName'];
        $pro_table = $classdata['TableName'];
        //************* Step 1 *************/
        $cron_data = array(
                'cron_file_name' => $file_name,
                'cron_start_time' => $curr_date,
                'property_class' => $className,
                'mls_no' => $curr_mls_id,
                'steps_completed' => 1
            );
        $curr_log_id = $dbcron->insert($cron_tablename, $cron_data);
        $start_pull = false;
        $last_success_query = "SELECT * FROM $cron_tablename where cron_file_name='" . $file_name . "' and property_class='" . $className . "' and mls_no ='" . $curr_mls_id . "' and success = 1 and cron_end_time<> '0000-00-00 00:00:00' and properties_download_end_time<>'0000-00-00 00:00:00' ORDER BY id DESC LIMIT 1 ";
        $last_cron_data     = $dbcron->rawQuery($last_success_query);
        if (count($last_cron_data) > 0) {
            $last_success_cron_end_time = $last_cron_data[0]['properties_download_end_time'];
            if ($last_success_cron_end_time == '' || $last_success_cron_end_time == '0000-00-00 00:00:00' || $last_success_cron_end_time == '0000-00-00') {
                $property_query_start_time = strtotime($start_pull_time, time());
                $property_query_start_time = date("Y-m-d H:i:s", $property_query_start_time);
            } else {
                $property_query_start_time = $last_success_cron_end_time;
            }
        } else {
            $default_date   = "2020-05-01T00:00:01";
            $start_pull     = true;
            $property_query_start_time = $default_date ;
        }
        
        $date_time                 = explode(' ', $property_query_start_time);
        $property_query_start_time = $date_time[0] . 'T' . $date_time[1];
        $date_query = "($timestamp_field=$property_query_start_time+)";
        
        $curr_timestamp = time();
        $old_timestamp  = strtotime($property_query_start_time);
        $diff           = ($curr_timestamp - $old_timestamp);
        $new_starttime             = 0;
        if ($diff > 3600 * 24 * 2) {
            $new_starttime = strtotime("+2 days", $old_timestamp);
        }
        if ($new_starttime > 0 && $new_starttime < time()) {
            $time_range1  = $property_query_start_time;
            $time_range2  = date('Y-m-d H:i:s', $new_starttime);
            $date_time2   = explode(' ', $time_range2);
            $datetime_range2   = $date_time2[0] . 'T' . $date_time2[1];
            $date_query = "($timestamp_field=$time_range1-$datetime_range2)";
            $property_end_time = $time_range2;
        } else {
            $property_end_time = $curr_date;
            $date_query  = "($timestamp_field=$property_query_start_time+)";
        }
        
        $status_query  = 'MlsStatus%20eq%20%27Active%27';
        $status_query  = '%28MlsStatus%20eq%20%27Active%27%20or%20MlsStatus%20eq%20%27Active%20With%20Contract%27%29';
        $status_query  = '%28MlsStatus%20eq%20%27Rented%27%20or%20MlsStatus%20eq%20%27Closed%20Sale%27%29';
        $property_query ='%20and%20PropertyType%20eq%20%27Residential%20Lease%27';
        $property_query ='%20and%20%28PropertyType%20eq%20%27Residential%27%20or%20PropertyType%20eq%20%27Commercial%20Sale%27%20or%20PropertyType%20eq%20%27Residential%20Income%27%20or%20PropertyType%20eq%20%27Land%27%29';
        $property_query = '';
        $status_query  = '%28MlsStatus%20eq%20%27Closed%20Sale%27%29';
        $token = '25776c801cbebcd59b8be657ab8d41b2';
        $status_query = 'MlsStatus%20eq%20%27Active%27';
        //$status_query ='ModificationTimestamp%20gt%20%272021-10-01T08:00:01%27';
        $new_starttime = strtotime("-2 days", time());
        $time_range2   = date('Y-m-d H:i:s', $new_starttime);
        $date_time2    = explode(' ', $time_range2);
        $last_date     = $date_time2[0] . 'T' . $date_time2[1];
        //$last_date   = '2022-01-14T00:00:00' ;
        $date_query = 'ModificationTimestamp%20gt%20'.$last_date.'' ;
        $curr_url = 'https://api.bridgedataoutput.com/api/v2/OData/itso/Property/replication?access_token='.$token.'&$filter='.$status_query;
        $curr_url = 'https://api.bridgedataoutput.com/api/v2/OData/itso/Property/replication?access_token='.$token.'&$filter='.$date_query;
        $count_url = $curr_url.'&$top=10';
        $rets_query = "$count_url";
        echo ''.$count_url;
        $cron_update_data = array(
              'properties_download_start_time' => $property_query_start_time,
              'steps_completed' => 2,
              'rets_query' => $count_url
            );
        $dbcron->where('id', $curr_log_id);
        $step2 = $dbcron->update($cron_tablename, $cron_update_data);   
        //exit;
        $get_all_data = getbridgedata($count_url);
        
        $inserted_prop = 0;
        $updated_prop = 0 ;
        $property_deleted = 0;
        
        if($get_all_data['status']==true){
            $next_link = (isset($get_all_data['json_data']['@odata.nextLink']) && $get_all_data['json_data']['@odata.nextLink']!='')?$get_all_data['json_data']['@odata.nextLink']:'';
            $total_count = isset($get_all_data['json_data']['value'])?count($get_all_data['json_data']['value']):0;
            $total_property_count = isset($get_all_data['json_data']['@odata.count'])?$get_all_data['json_data']['@odata.count']:0;
            echo "<br> Total Property Count : ".$total_property_count ;
            $cron_update_data = array(
                'properties_count_from_mls' => $total_property_count,
                'steps_completed' => 3
                );
            $dbcron->where('id', $curr_log_id);
            $step2 = $dbcron->update($cron_tablename, $cron_update_data);   

            $properties_inserted_in_db = 0;
            $insertion_prop            = 0;
            $update_prop               = 0;
            $limit = 2000;
            $start_index = 0 ;
            echo "<pre>";
            $total_listings_im = 0;
            $next_link = '';
            $lc = (($total_property_count-$start_index)/$limit);
            $complete_counter = $total_property_count ;
            for ($lcp=0 ;$lcp<=$lc ;$lcp++) {
                $offset =  $start_index + $lcp*$limit ;
                $curr_url_fetch = $curr_url.'&$top='.$limit.'&$skip='.$offset ;                            
                $remaining = $total_property_count-$properties_inserted_in_db ;
                if($offset==0){
                    $next_link = $curr_url_fetch ;
                }
                $curr_data = getbridgedata($next_link);
                $next_link = (isset($curr_data['json_data']['@odata.nextLink']) && $curr_data['json_data']['@odata.nextLink']!='')?$curr_data['json_data']['@odata.nextLink']:'';
                if($curr_data['status']==true){
                    $all_properties = $curr_data['json_data']['value'] ;
                    foreach($all_properties as $record){
                        echo "<br>".$listing_key = $record[ $mls_key_field ];
                        //print_r($record);
                        $curr_time = date('Y-m-d H:i:s');
                        $property_data = array();
                        /*$property_data['ListingId']  = $record['ListingId'];
                        $property_data['Status']     = $record['MlsStatus'];
                        $property_data['created_at'] = $curr_time;
                        $p_insert = $dbproperty->insert('tmp_prp',$property_data);
                        */
                        $property_data = array();
                        foreach( $reso_mapping as $db_key=>$mls_key ){
                            if( isset($record[ $mls_key ]) && !empty( $record[ $mls_key ] ) ){    
                                if(is_array($record[ $mls_key ])){
                                    $property_data[ $db_key ] = serialize($record[ $mls_key ]);
                                } else {
                                    $property_data[ $db_key ] = $record[ $mls_key ];
                                }
                            } else {
                                $property_data[ $db_key ] = '';
                            }
                        }
                        $curr_time = date('Y-m-d H:i:s');
                        $property_data['updated_at'] = $curr_time;
                        $pro_table_temp = 'property_dump';
                        $last_tmp_data     = $dbproperty->rawQuery("SELECT id FROM $pro_table_temp where $mls_key_field='$listing_key'");
                        if (count($last_tmp_data) > 0) {
                            $dbproperty->where('ListingId', $listing_key);
                            $ste = $dbproperty->update($pro_table_temp, $property_data);  
                        } else {
                            $property_data['created_at'] = $curr_time;
                            $p_insert = $dbproperty->insert($pro_table_temp,$property_data);
                        }
                        $common_data = array();
                        $common_data['mls_no'] = 2;
                        $trim = array(
                            'Timestamp_sql','Pix_updt'
                        );
                        
                        foreach( $com_map as $db_key=>$mls_key ){
                            if( isset($record[ $mls_key ]) && !empty( $record[ $mls_key ] ) ){    
                                if(is_array($record[ $mls_key ])){
                                    $common_data[ $db_key ] = implode(',',$record[ $mls_key ]);//serialize($record[ $mls_key ]);
                                } else {
                                    if( in_array($db_key,$trim)){
                                        if( $record[ $mls_key ]==''){
                                            $common_data[ $db_key ] = NULL;
                                        } else {
                                            $a = explode(".",$record[$mls_key]);
                                            $common_data[ $db_key ] = $a[0];
                                        }
                                    } else {
                                        $common_data[ $db_key ] = $record[ $mls_key ];
                                    }
                                }
                            } else {
                                $common_data[ $db_key ] = '';
                            }
                        }
                        $curr_time = date('Y-m-d H:i:s');
                        $common_data['property_last_updated'] = $curr_time;
                        /*$common_data['Longitude'] = $record['Coordinates'][0];
                        $common_data['Latitude'] = $record['Coordinates'][1];
                        */
                        
                        $common_data['thumbnail'] = $record['Media'][0]['MediaURL'];
                        $common_data['Prop_feat1_out'] = $record['Inclusions'];
                        $common_data['Prop_feat2_out'] = implode(',',$record['LotFeatures']);
                        $common_data['Prop_feat3_out'] = implode(',',$record['ExteriorFeatures']);
                        $common_data['Prop_feat4_out'] = implode(',',$record['InteriorFeatures']);
                        $common_data['Prop_feat5_out'] = implode(',',$record['AccessibilityFeatures']);
                        $common_data['Prop_feat6_out'] = implode(',',$record['SecurityFeatures']);
                        //$common_data['Prop_feat6_out'] = implode(',',$record['Cooling']);
                        
                        $address = '';
                        $address .= isset($record['StreetNumber'])?$record['StreetNumber'].' ' :'';
                        //$address .= isset($record['St_dir'])?$record['St_dir'].' ' :'';
                        $address .= isset($record['StreetName'])?$record['StreetName'].' ' :'';
                        $address .= isset($record['StreetSuffix'])?$record['StreetSuffix'].' ' :'';
                        $address .= isset($record['UnitNumber'])?$record['UnitNumber'].' ' :'';
                        $full_address = $address ;
                        $full_address .= isset($record['City'])?$record['City'].' ':'';
                        $full_address .= isset($record['CountyOrParish'])?$record['CountyOrParish'].' ':'';
                        $full_address .= isset($record['PostalCode'])?$record['PostalCode'].' ':'';
                        
                        if($record['PropertyType']=='Residential' || $record['PropertyType']=='Residential_Income' || $record['PropertyType']=='Residential_Lease'){
                            $classType = 'Residential';
                        } else if($record['PropertyType']=='Commercial_Lease' || $record['PropertyType']=='Commercial_Sale'){
                            $classType = 'Commercial';
                        } else {
                            $classType = 'Condos';
                        }
                        $address = preg_replace('/\s+/',' ',$address);
                        $address = preg_replace('/\,/','',$address);
                        
                        $full_address = preg_replace('/\s+/',' ',$full_address);
                        $full_address = preg_replace('/\,/','',$full_address);
                        
                        $full_address  = trim($address).', ' .$record['City']. ' '.$record['CountyOrParish'].' '.$record['PostalCode'] .' '. $record['ListingId'];
                        $title = $address.'-'.$record['City'].'-'.$record['CountyOrParish'].'-' .$record['PostalCode'].'-'.$record['ListingId'];
                        $title  = preg_replace('/\s+/', ' ', $title);
                        $title  = trim($title);
                        $title  = str_ireplace("-", " ", $title) ;
                        $title  = preg_replace('/\s+/', ' ', $title); 
                        $tags    = strip_tags($title);
                        $tags    = preg_replace('/\s+/', '-', $tags);
                        $tags    = preg_replace('/\-+/', '-', $tags);
                        $vowels   = array(" ", ",", ".","#");
                        $filtered = str_replace($vowels, "-", $tags);
                        $filtered = preg_replace('/\-+/', '-', $filtered);
                        
                        $common_data['FilteredAddress'] = $address;
                        $common_data['full_address'] = $full_address;
                        $common_data['slug_url'] = $filtered;
                        $common_data['ClassType'] = $classType;
                        $common_data['cityname_formatted'] = trim($record['City']);
                        $common_data['mls_no'] = $curr_mls_id;
                        $common_data['property_last_updated'] = date('Y-m-d H:i:s');
                        
                        
                        if(isset($record['Media']) && count($record['Media'])>0){
                            $sysid = $record['ListingId'];
                            $pic_count = 0;
                            $image_table_name = 'rets_property_data_resi_image';
                            $dl = "DELETE FROM $image_table_name where L_DisplayId='".$sysid."'";
                            $dbproperty->rawQuery($dl);
                            foreach($record['Media'] as $image){
                                $pic_count++;
                                $image_data = array();
                                $image_data['image_path']   = $image['MediaURL'];
                                $image_data['L_DisplayId']  = $sysid;
                                $image_data['L_ListingID']  = $sysid;
                                $image_data['mls_no']    = $curr_mls_id ;
                                $image_data['image_directory']   = '' ;
                                $image_data['image_name']        = '';
                                $image_data['downloaded_time']   = date('Y-m-d H:i:s');
                                $image_data['sort_order_no']     = $pic_count;
                                $property_insert = $dbproperty->insert($image_table_name,$image_data);
                                
                                $errorp = $dbproperty->getLastError();
                                if(!empty($errorp)){
                                    print_r($errorp);
                                    exit;
                                }
                            }
                        }
                        //print_r($common_data);
                        //exit;
                        $rets_table = "rets_property_data";
                        $last1     = $dbproperty->rawQuery("SELECT id FROM $rets_table where $mls_key_field='$listing_key'");
                        if (count($last1) > 0) {
                            $dbproperty->where('ListingId', $listing_key);
                            $ste = $dbproperty->update($rets_table, $common_data);  
                            
                        } else {
                            $inserted_prop++;
                            $property_data['property_insert_time'] = $curr_time;
                            $p_insert = $dbproperty->insert($rets_table,$common_data);
                            if ($p_insert) {
                                echo "\n".'Property was created. Id=' . $p_insert;
                            } else {
                                echo "\n".'insert failed: ' . $dbproperty->getLastError();
                                exit;
                            }
                        }
                    }
                }
            }
        }
        //exit;
        $cron_update_data4 = array(
            'cron_end_time' => date('Y-m-d H:i:s'),
            'steps_completed' => 4,
            'success' => 1,
            'property_inserted' => $inserted_prop,
            'property_deleted' => $property_deleted,
            'property_updated' => $updated_prop,
            'properties_download_end_time' => $property_end_time,
            'properties_count_actual_downloaded' => $properties_inserted_in_db         
        );
        $dbcron->where('id', $curr_log_id);
        $step4 = $dbcron->update($cron_tablename, $cron_update_data4);  


    }